part of tags;

/// A mixin that provides dynamic styling to a custom element. 
abstract class Themeable {
  
  /// Returns the resources of this themeable.
  Resources get resources;
  
  /// Returns the style element of this themeable.
  get styleElement;
  
  /// Refreshes the [styleElement] with the current style given by the 
  /// [resources].
  void refreshStyle() {
    styleElement.text = resources.style;
  }
}
