part of tags;

abstract class Tree<T> {
  
// -----------------------------------------------------------------------------
// Implemented in the TreeView base class; not designed for override.
// -----------------------------------------------------------------------------
  
  T get data;  
  List<Tree> get logicalChildren;
  Tree get logicalParent;  
  bool isExpanded;
  
  void initialize(T data, [Tree logicalParent]);
  void shutdown();
  
  void refresh();
  void removeChildren(bool predicate(Tree tree));
  void renderChildren();
  void toggleExpanded();
  
// -----------------------------------------------------------------------------
// Stubbed in the TreeView base class and designed for override.
// -----------------------------------------------------------------------------
  
  Command get copy;
  Command get cut;
  Command get delete;
  Command get paste;
  Command get rename;
  
  void initialize_(T data);
  void shutdown_();  
  
  void showContextMenu_();
  void hideContextMenu_();
  
  void singleClick_();
  void doubleClick_();
  
  void collapse_();
  void expand_();
  
  void attached_();
  void detached_();
  
  void select_();
  void unselect_();
}
