part of tags.html;

/// A control that allows toggling the presentation of its `.open` content.
class ToggleOpen extends HtmlElement with Toggleable {
  
  static const TAG = 'toggle-open';

  StreamSubscription<MouseEvent> _documentClickListener;

  /// Creates a new toggle-open.
  factory ToggleOpen() => dom.createElement(TAG);
  
  ToggleOpen.created() : super.created() {
    ContentElement _content;
    children(this, () {
      shadow(() {
        content()..select='.toggle';
        // Selecting '.toggle' here is a way to ensure it selects nothing, as
        // the distribution will always go to the first match for '.toggle'.
        _content = content()..select='.toggle';       
      });
    })
    ..onClick.listen((MouseEvent ev) {
      ev.stopPropagation();
      toggle();
    })
    ..onKeyUp.listen((KeyboardEvent ev) {
      if (ev.keyCode == KeyCode.ESC) {
        isDown = false;
      }
    })
    ..onToggle.listen((bool down) {
      if (down) {
        _content.select = '.open';
        _documentClickListener = 
            document.onClick.listen((MouseEvent ev) => isDown = false);
      } else {
        _documentClickListener.cancel();
        _content.select = '.toggle';
      }
    });
  }
}
